"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

exports.__esModule = true;
exports.getGlobalConfig = getGlobalConfig;
exports.setGlobalConfig = setGlobalConfig;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/extends"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _contracts = require("./contracts");

/* eslint-disable global-require */
var globalConfig = {};

function getGlobalConfig() {
  loadGlobalConfig();
  return globalConfig;
}

function setGlobalConfig(config) {
  globalConfig = config;
} // region load config


var globalConfigLoaded = false;

function loadGlobalConfig() {
  if (globalConfigLoaded) {
    return;
  }

  globalConfigLoaded = true;

  var configFile = _path.default.resolve(process.cwd(), process.env[_contracts.GLOBAL_CONFIG_ENV] || '.run-script-rc.js');

  if (_fs.default.existsSync(configFile)) {
    var config = require(configFile);

    setGlobalConfig((0, _extends2.default)({}, getGlobalConfig(), config));
  } else if (process.env[_contracts.GLOBAL_CONFIG_ENV]) {
    throw new Error('Config file not found: ' + configFile);
  }
} // endregion